<?php
/**
 * Conversation Update.
 *
 * @package    Woo_Sell_Services
 * @subpackage Woo_Sell_Services
 * @author     Wbcom Designs <admin@wbcomdesigns.com>
 */

/**
 * Service Conversation update.
 */
function woo_sell_service_conversation_update() {
	global $wbwss_globals,$wpdb;
	ob_start();
	$woo_table = $wpdb->prefix . 'wss_sell_messages';

	$woo_item_id     = sanitize_text_field( $_REQUEST['wss_itemid'] );
	$woo_order_id    = sanitize_text_field( $_REQUEST['wss_orderid'] );
	$current_user_id = get_current_user_id();

	if ( '' == $woo_item_id && '' == $woo_order_id ) {
		wp_die();
	}

	$arr_item_meta = wc_get_order_item_meta( $woo_item_id, '' );
	$order = wc_get_order($woo_order_id);
	if ($order) {
		$order_status = $order->get_status();
	}

	$item_name  = '';
	$item_price = '';
	$items      = array();
	if ( ! empty( $arr_item_meta ) ) {
		$items['product_id']    = $arr_item_meta['_product_id'][0];
		$items['product_price'] = $arr_item_meta['_line_total'][0];

		if ( isset( $arr_item_meta['_variation_id'] ) ) {
			$items['variation_id'] = $arr_item_meta['_variation_id'][0];
		}
	}

	$woo_author             = get_post( $items['product_id'] ); // gets author from post.
	$woo_sell_service_users = get_post_meta( $items['product_id'], 'woo_sell_service_users', true );
	if ( ! $woo_sell_service_users ) {
		$woo_sell_service_users = array();
	}
	if ( ! empty( $woo_sell_service_users ) && in_array( $current_user_id, $woo_sell_service_users ) ) {
		$woo_author_id = $current_user_id;
	} else {
		$woo_author_id = $woo_author->post_author;
	}
	$woo_sell_service_users[] = $woo_author->post_author;
	$woo_author_ids           = implode( ',', $woo_sell_service_users );
	$woo_author_data          = get_userdata( $woo_author_id );
	$woo_author_name          = $woo_author_data->data->display_name;

	//$customer_id = get_post_meta( $woo_order_id, '_customer_user', true );
	$order = wc_get_order($woo_order_id);
	if ($order) {
		$customer_id = $order->get_customer_id();
	}
	$customer    = get_userdata( $customer_id );

	$order_conversation    = $wbwss_globals->wss_requirement_images( 'order_conversation' );
	$final_dlvry_sent_img  = $wbwss_globals->wss_requirement_images( 'final_dlvry_sent' );
	$final_dlvry_accpt_img = $wbwss_globals->wss_requirement_images( 'final_dlvry_accpt' );
	$final_dlvry_deny      = $wbwss_globals->wss_requirement_images( 'final_dlvry_deny' );
	$order_review_img      = $wbwss_globals->wss_requirement_images( 'order_review' );
	$order_comp_img        = $wbwss_globals->wss_requirement_images( 'order_comp' );

	$client = $customer->data->display_name;
	$vendor = $woo_author_name;

	$woo_conversation = $wpdb->get_results( "SELECT * FROM $woo_table WHERE author_id IN ($woo_author_ids) AND order_id = $woo_order_id AND item_id = $woo_item_id ORDER BY id DESC LIMIT 1" );

	$woo_conversation_all = $wpdb->get_results( "SELECT * FROM $woo_table WHERE author_id IN ($woo_author_ids) AND order_id = $woo_order_id AND item_id = $woo_item_id ORDER BY id DESC" );

	if ( ! empty( $woo_conversation ) ) {

		$tempdate = '';
		foreach ( $woo_conversation as $conversation ) {
			$conversationID = $conversation->id;
			$akey           = WOO_ACCEPT_DELIVERY . '_' . $conversationID;
			$fkey           = WOO_FINAL_DELIVERY . '_' . $conversationID;

			$final_deliver  = false;
			$final 			= '';
			$deliver_status = get_post_meta( $woo_item_id, $akey, true );
			if ( '' == $deliver_status ) {
				$deliver_status = wc_get_order_item_meta( $woo_item_id, $akey );
			}

			$final_conversation_id = wc_get_order_item_meta( $woo_item_id, $fkey );
			$final_conversation_id = get_post_meta( $woo_item_id, $fkey, true );
			if ( '' == $final_conversation_id ) {
				$final_conversation_id = wc_get_order_item_meta( $woo_item_id, $fkey );
			}

			$wooAuthor = get_userdata( $conversation->user_id );
			$msgTime   = $conversation->msg_time;
			$msgDate   = explode( ' ', $msgTime );

			if ( isset( $_REQUEST['id'] ) && $conversation->id != $_REQUEST['id'] ) {
				if ( count( $woo_conversation_all ) == 1 ) {
					?>
				<div class="wss-container wbcom-wss-conversation-container">
					<div class="header-sell-order">
						<div class="header-sell-order-thumb"><img src="<?php echo esc_attr( $order_conversation ); ?>" alt="<?php esc_html_e( 'Conversation', 'woo-sell-services' ); ?>"></div>
						<div class="header-sell-order-dec">
							<h3 class="sell-order-title"><?php echo apply_filters( 'wss_conversation_heading', esc_html__( 'Conversation', 'woo-sell-services' ) ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?></h3>
						</div>
					</div>
					<?php
				}
				if ( $tempdate != $msgDate[0] ) {
					$date = date( 'jS F, Y', strtotime( $msgDate[0] ) );
					echo '<div class="woo-msg-time"><div class="woo-msg-date-wrap">';
					echo esc_html( date_i18n( get_option( 'date_format' ), strtotime( $msgDate[0] ) ) );
					echo '</div></div>';
				}

				$tempdate = $msgDate[0];
				if ( true || $conversation->message && $conversation->attachment ) {
					if ( get_current_user_id() == $conversation->user_id ) {
						$wss_msz_class = 'wss-receiver-msg';
					} else {
						$wss_msz_class = 'wss-sender-msg';
					}
					if ( $final_conversation_id == $conversationID ) {
						$final_deliver = true;
					}
					$conversation_id = $conversation->id;
					?>
					<div id="woo-single-ms-<?php echo esc_attr( $conversation->id ); ?>" data-id="<?php echo esc_attr( $conversation->id ); ?>" class="woo-single-msg <?php echo esc_attr( $wss_msz_class ); ?>">
						<?php
						if ( wc_get_order_item_meta( $woo_item_id, $fkey ) == $conversation->id ) {
							?>
								<div class="wss-sell-product">
									<img src="<?php echo esc_url( $final_dlvry_sent_img ); ?>" alt="<?php esc_html_e( 'Order Requirement', 'woo-sell-services' ); ?>">
									<div class="wss-sell-order-reuirments-head">
										<?php
										if ( $conversation->user_id != $woo_author_id && ! empty( $woo_sell_service_users ) && in_array( $current_user_id, $woo_sell_service_users ) ) {
											/* translators: %1$s: WooCommerce Seller, %2$s: Customer */
											echo sprintf( esc_html__( '%1$s sent final delivery to %2$s', 'woo-sell-services' ), esc_html( ucfirst( $wooAuthor->display_name ) ), esc_html( $client ) );

										} elseif ( $conversation->user_id == $woo_author_id && $current_user_id == $woo_author_id ) {
											/* translators: %s: Customer */
											echo sprintf( esc_html__( 'You sent final delivery to %s', 'woo-sell-services' ), esc_html( $client ) );
										} else {
											/* translators: %s: WooCommerce Seller */
											echo sprintf( esc_html__( '%s sent you final delivery!', 'woo-sell-services' ), esc_html( ucfirst( $wooAuthor->display_name ) ) );
										}
										?>
									</div>
								</div>
							<?php
						}
						if ( ! empty( $deliver_status ) && isset( $deliver_status['final'] ) ) {

							if ( 'yes' == $deliver_status['final'] && $conversation->id == $deliver_status['id'] ) {
								$final = 'true';
								?>
								<div class="wss-sell-product">
									<img src="<?php echo esc_url( $final_dlvry_accpt_img ); ?>" alt="Order Requirement">
									<?php
									if ( get_current_user_id() == $woo_author_id ) {
										?>
										<div class="wss-sell-order-reuirments-head">
											<?php
											/* translators: %s: WooCommerce Seller */
											echo sprintf( esc_html__( '%s accepted your final delivery!', 'woo-sell-services' ), esc_html( $client ) );
											?>
										</div>
										<?php
									} else {
										?>
										<div class="wss-sell-order-reuirments-head">
										<?php
										/* translators: %s: WooCommerce Vendor */
										echo sprintf( esc_html__( 'You accepted final delivery of %s', 'woo-sell-services' ), esc_html( $vendor ) );
										?>
										</div>
										<?php
									}
									?>
								</div>
								<?php
							}
							if ( ! empty( $deliver_status ) && 'no' == $deliver_status['final'] && $conversation->id == $deliver_status['id'] ) {
								$final = 'false';
								?>
									<div class="wss-sell-product">
										<img src="<?php echo esc_attr( $final_dlvry_deny ); ?>" alt="<?php esc_html_e( 'Order Requirement', 'woo-sell-services' ); ?>">
										<div class="wss-sell-order-reuirments-head">
									<?php
									if ( get_current_user_id() == $woo_author_id ) {
										?>
												<div class="wss-sell-order-reuirments-head">
											<?php
											/* translators: %s: WooCommerce Seller */
											echo sprintf( esc_html__( '%s did not accepted your final delivery!', 'woo-sell-services' ), esc_html( $client ) );
											?>
												</div>
											<?php
									} else {
										?>
												<div class="wss-sell-order-reuirments-head">
											<?php
											/* translators: %s: WooCommerce Vendor */
											echo sprintf( esc_html__( 'You did not accepted final delivery of %s !', 'woo-sell-services' ), esc_html( $vendor ) );
											?>
												</div>
											<?php
									}
									?>
										</div>
									</div>
									<?php
							}
						}
						?>
						<div class="woo-author-conversation-wrapper">
							<div class="woo-msg">
								<div class="woo-msg-sec">
									<div class="wss-msz-text">
										<?php echo ( ! empty( $conversation->message ) ? wp_kses_post( wpautop( $conversation->message ) ) : '' ); ?>
									</div>
								</div>
							</div>
							<div class="woo-author-details">
								<?php echo get_avatar( $conversation->user_id, 70 ); ?>
							</div>
						</div>
						<div class="woo-author-message">
							<div class="woo-name-file-wrapper">
								<div class="woo-name">
									<span><?php echo esc_attr( $wooAuthor->data->display_name ); ?></span>
									<div class="woo-time">
										<?php echo esc_attr( $msgDate[1] ); ?>
									</div>
								</div>
								<?php
								$files = unserialize( $conversation->attachment );
								if ( ! empty( $files ) ) {
									echo '<div class="woo-file"><span>';
									esc_html_e( 'Attachment files', 'woo-sell-services' );
									echo '</span>';
									echo '<ul>';
									foreach ( $files as $fileID ) {
										$fileData = get_post( $fileID );
										echo '<li><a href="' . esc_url( $fileData->guid ) . '" download>';
										echo esc_attr( $fileData->post_name ) . '  ';
										echo '</a></li>';
									}
									echo '</ul></div>';
								}
								?>
							</div>
						</div>
					<?php

				}
				if ( count( $woo_conversation_all ) == 1 ) {
					echo '</div>';  // wss-container.
				}
			}
		}
		$update_conversation = ob_get_clean();
		echo json_encode(
			array(
				'success'               => true,
				'message'               => $update_conversation,
				'final_delivery'        => $final_deliver,
				'final_delivery_accept' => $final,
			)
		);
	} else {
		echo 'empty';
	}
	wp_die();
}
add_action( 'wp_ajax_conversation_update', 'woo_sell_service_conversation_update' );
add_action( 'wp_ajax_nopriv_conversation_update', 'woo_sell_service_conversation_update' );
